-- Retrieving all index information (create-script) for non-pk and non-unique indexes
-- $Id: generate_create_index.sql,v 1.1 2006/12/18 18:35:38 izzy Exp $

SET SERVEROUTPUT ON FEEDBACK OFF
SPOOL create_indexes.sql
DECLARE
  town VARCHAR2(40) := '0';
  CURSOR cur IS
    SELECT i.owner,i.index_name
      FROM dba_indexes i,dba_constraints c
     WHERE i.owner = c.owner(+)
       AND i.index_name = c.index_name(+)
       AND c.index_name IS NULL
       AND i.index_type NOT LIKE 'IOT%'
       AND i.index_type != 'LOB'
       AND i.owner NOT IN ('SYS','SYSTEM','CSMIG','CTXSYS','DBSNMP','DMSYS','EXFSYS',
                           'HR','IX','MDSYS','OE','OLAPSYS','ORDSYS','OUTLN',
                           'SH','SYSMAN','WKSYS','WK_TEST','WMSYS','XDB')
     ORDER BY i.owner,i.index_name;
  PROCEDURE print(line IN VARCHAR2) IS
    -- wrapper to dbms_output.put_line - work around the 255 characters limit
    pos NUMBER;
    FUNCTION strpos (str IN VARCHAR2,needle IN VARCHAR2,startpos NUMBER) RETURN NUMBER IS
      -- split string helper to procedure print
      pos NUMBER; strsub VARCHAR2(255);
      BEGIN
        strsub := SUBSTR(str,1,255);
        pos    := INSTR(strsub,needle,startpos);
        return pos;
      END;
    BEGIN
      dbms_output.put_line(line);
    EXCEPTION
      WHEN OTHERS THEN
        IF SQLERRM LIKE '%ORU-10028%' THEN
          pos := strpos(line,' ',-1);
	  print(SUBSTR(line,1,pos));
	  pos := pos +1;
	  print(SUBSTR(line,pos));
	ELSE
      dbms_output.put_line('-- *!* Problem in print() *!*');
	END IF;
    END;
BEGIN
  dbms_output.enable(1000000);
  FOR rec IN cur LOOP
    IF town != rec.owner THEN
      town := rec.owner;
      print('-- ===============================[ Schema '||town||' ]===');
    END IF;
    print(dbms_metadata.get_ddl('INDEX',rec.index_name,rec.owner)||';');
  END LOOP;
END;
/
SPOOL OFF
